module.exports = function (grunt) {
  var jQuery = 'src/<%= pkg.name %>.jquery.dev.js',
      vanilla = 'src/<%= pkg.name %>.dev.js',
      jQueryMin = 'dist/<%= pkg.name %>.jquery.min.js',
      vanillaMin = 'dist/<%= pkg.name %>.min.js';

    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),

        jshint: {
            jquery: {
                src: [jQuery],
                options: { globals: { jQuery: true } }
             },

             vanilla: {
                 src: [vanilla],
                 options: { /* ... */ }
             }
        },
        
        jsonlint: {
            src: ['package.json', 'bower.json']
        },

        uglify: {
            build: {
                options: {
                    banner: '/* <%= pkg.name %> <%= pkg.version %> license:<%= pkg.license %> */',
                },
                files: [{
                    src: jQuery,
                    dest: jQueryMin
                },{
                    src: vanilla,
                    dest: vanillaMin
                }]
            }
        }
    });

    grunt.loadNpmTasks('grunt-contrib-jshint');
    grunt.loadNpmTasks('grunt-contrib-uglify');
    grunt.loadNpmTasks('grunt-jsonlint');
    
    grunt.registerTask('default', [
        'jshint:jquery', 'jshint:vanilla',
        'uglify',
        'jsonlint'
    ]);
};
