# jColumn
[![bower](https://img.shields.io/bower/v/jcolumn.svg)](http://bower.io)
[![npm](https://img.shields.io/npm/v/jcolumn.svg)](https://www.npmjs.com/package/jcolumn)
[![Build tool](https://img.shields.io/badge/build%20tool-grunt-red.svg)](http://gruntjs.com)
[![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://opensource.org/licenses/MIT)


jColumn is a lightweight JavaScript library to make selected html elements the same height.
It can be used as a standalone JavaScript library or a jQuery plugin.
Size: 861 Bytes

### Without jColumn

![without jcolumn screenshot](http://oliverj.net/img/jqueryplugins/without-jcolumn.png)

### With jColumn
![with jcolumn screenshot](http://oliverj.net/img/jqueryplugins/with-jcolumn.png)

## Install
### Bower
```html
bower install jcolumn
```

### npm
```html
npm install jcolumn
```

### The oldschool way
#### JavaScript
```html
<script src="dist/jcolumn.min.js" type="text/javascript" charset="utf-8"></script>
```

#### jQuery
Include the jcolumn.jquery.min.js script directly after [jQuery](http://jquery.com):

```html
<script src="dist/jcolumn.jquery.min.js" type="text/javascript" charset="utf-8"></script>
```

## Usage
### JavaScript
Just create an instance of jColumn and invoke the method jcolumn.
The method takes a class name (without a point) as parameter.

```javascript
var col = new jColumn();
col.jcolumn('col');
```

#### Options

Option     | Default  | Type      | Description
---------- | -------- | --------  | --------
delay      | 500      | number    | (optional) The delayed time after the resize happens
maxWidth   | 767      | number    | (optional) Every document width smaller than maxWidth will not use jcolumn
resize     | true     | boolean   | (optional) Disable resize event with false
callback   | null     | function  | (optional) A callback function which gets triggered after resize


```javascript
var col = new jColumn({
    delay: 500,
    maxWidth: 767,
    callback: function (height) {
        console.log('New max height is: ' + height);
    }
});
col.jcolumn('col');
```

### jQuery
Initialize the plugin by calling the jcolumn function on a class of columns.

```javascript
$('.col').jcolumn();
```

#### Options

Option   | Default  | Type      | Description
-------- | -------- | --------  | --------
delay    | 500      | number    | (optional) The delayed time after the resize happens
maxWidth | 767      | number    | (optional) Every document width smaller than maxWidth will not use jcolumn
resize   | true     | boolean   | (optional) Disable resize event with false
callback | null     | function  | (optional) A callback function which gets triggered after resize


```javascript
$('.col').jcolumn({
    delay: 500,
    maxWidth: 767,
    callback: function (height) {
        console.log('New max height is: ' + height);
    }
});
```

## How to build your own version

If you would like to build your own version of jColumn, the only thing you need to do is to follow the steps below.

```javascript
$ cd jcolumn
$ npm install
$ grunt
```

## Browser compatibility
- Chrome 1+
- FireFox 6+
- Safari 4+
- Opera 10+
- Internet Explorer (Sry I do not have a Windows Machine)


### Author

Oliver Jessner [@oliverj_net](https://twitter.com/oliverj_net)

Copyright © 2015- 2016
