// version 0.1.2
// visit: http://oliver-j.github.io/jcolumn/
;(function ($, win, doc) { 'use strict';
    $.fn.jcolumn = function (options) {

    var elements = this;

    var defaults = {
        delay: 500,
        maxWidth: 767,
        responsive: true,
        callback: function (elemH) {}, // noop
        resize: true
    };

    var settings = $.extend( {}, defaults, options);

    // otherwise the event would trigger the function to fast
    var delay = (function () {
		var timer = 0;
        
	  	return function(callback, ms){
	    	clearTimeout(timer);
	    	timer = setTimeout(callback, ms);
	  	};
	})();

	function resizeColumnHeight (columns) {
		var elemH = 0,
            $this = null,
            $thisHeight = 0;

		if ($(doc).width() >= settings.maxWidth) {
            columns.each(function () {
			    $this = $(this);
			    $this.height('auto');
                $thisHeight = $this.height();

			    if ($thisHeight > elemH) {
				    elemH = $thisHeight;
			    }
		    });

			columns.each(function () {
				$(this).height(elemH);
			});

            settings.callback(elemH);
		}
	}

    // wrapper function for init and event
    function magic () {
        delay(resizeColumnHeight(elements), settings.delay);
    }

    if (settings.resize) {
	    win.addEventListener('resize', magic);
    }

    magic();

    return this;
};
}(jQuery, window, document));
